#!/bin/bash
#
# oldnet2new.sh
#
# Copyright (c) 2002 SuSE GmbH Nuernberg, Germany.  All rights reserved.
#
# Author: Karsten Keil <kkeil@suse.de>
#
#
#

function write_var () {
  eval VAL=\$${2}${1}
  if [ -n "$VAL" ]; then
    echo "${3}=\"${VAL}\"" >> $OUT_FILE
  else
    if [ -n "${4}" ]; then
      if [ "${4}" = "X" ]; then
        echo "${3}=\"\"" >> $OUT_FILE
      else
        echo "${3}=\"${4}\"" >> $OUT_FILE
      fi
    fi
  fi
}

function test_hw () {
  HWLST=`echo $HWLST`
  [ -n "$HWLST" ] && for n in $HWLST ; do
    eval ITYP_=\$ITYP_$n
    for x in $ITYP_ ; do
        if [ "$x" = "$ITYP" ]; then
          eval UNIQUE=\$UNID_$n
	  HWLST=${HWLST/$n/}
          HWIDX=$n
          return
        fi
    done
  done
  [ -n "$HWLST" ] && for n in $HWLST ; do
    eval ITYP_=\$ITYP_$n
    it=${ITYP%/*}
    for x in $ITYP_ ; do
        y=${x%/*}
        if [ "$y" = "$it" ]; then
          eval UNIQUE=\$UNID_$n
	  HWLST=${HWLST/$n/}
          HWIDX=$n
          return
        fi
    done
  done
  HWIDX=""
}

if [ -f etc/rc.config ]; then
  . etc/rc.config
fi
[ -f etc/rc.config.d/i4l_unknown.rc.config ] && . etc/rc.config.d/i4l_unknown.rc.config
if [ -f etc/rc.config.d/i4l.rc.config ]; then
  . etc/rc.config.d/i4l.rc.config
  mv etc/rc.config.d/i4l.rc.config etc/rc.config.d/i4l.rc.config.old
else
  echo "no etc/rc.config.d/i4l.rc.config"
  exit 0
fi
TMPCFG=""
for i in etc/sysconfig/network/* ; do
  case $i in
    *~*) ;;
    *.*) ;;
    etc/sysconfig/network/tmpcfg-i*) TMPCFG="$TMPCFG $i" ;;
    *) ;;
  esac
done 
O="0"
[ -n "$TMPCFG" ] && for tf in $TMPCFG ; do
  OUTFILE=etc/sysconfig/isdn/cfg-net$O
  OUT_FILE=${OUTFILE}.new
  echo -n "$tf --> $OUTFILE"
  PROVIDER=iprovider$O
  PROVFILE=etc/sysconfig/network/providers/$PROVIDER
  O=$(($O + 1))
  echo "# generated by oldi4l2new.sh from $tf" > $OUT_FILE
  echo "#" >> $OUT_FILE
  echo "PROVIDER=\"$PROVIDER\"" >> $OUT_FILE
  echo "# generated by oldi4l2new.sh from $tf" > $PROVFILE
  echo "PROVIDER=\"$PROVIDER\"" >> $PROVFILE
  echo "ISDNSUPPORTED=\"yes\"" >> $PROVFILE
  DYNAMICIP=""
  NETDEV=${tf#etc/sysconfig/network/tmpcfg-}
  . $tf
  echo "Protocol=\"$PROTOCOL\"" >> $PROVFILE
  echo "PROTOCOL=\"$PROTOCOL\"" >> $OUT_FILE
  echo "STARTMODE=\"$STARTMODE\"" >> $OUT_FILE
  echo "IPADDR=\"$IPADDR\"" >> $OUT_FILE
  echo "PTPADDR=\"${PTPADDR}\""  >> $OUT_FILE
  echo "DYNAMICIP=\"${DYNAMICIP}\""  >> $OUT_FILE
  I=$NETINDEX
  write_var $I I4L_LOCALMSN MSN 0
#  write_var $I I4L_REMOTE_OUT REMOTE_OUT X
  eval PHONE=\$I4L_REMOTE_OUT$I
  echo "PHONE=\"$PHONE\"" >> $PROVFILE
  write_var $I I4L_REMOTE_IN REMOTE_IN X
  write_var $I I4L_SECURE SECURE on
  write_var $I I4L_CHARGEHUP CHARGEHUP off
  write_var $I I4L_IHUP IHUP off
  write_var $I I4L_DIALMODE DIALMODE manual
  write_var $I I4L_CALLBACK CALLBACK off
  write_var $I I4L_CBDELAY CBDELAY
  write_var $I I4L_CBHUP CBHUP
  write_var $I I4L_IDLETIME IDLETIME
  write_var $I I4L_DIALMAX DIALMAX
  eval MULTI=\$I4L_SLAVE_$I
  if [ -n "$MULTI" ]; then
    echo "MULTILINK=\"yes\"" >> $OUT_FILE
    write_var $I I4L_SLAVE SLAVES
    write_var $I I4L_SLAVEMSN SLAVEMSN
    write_var $I I4L_SLAVE_OUT SLAVE_OUT
    write_var $I I4L_SLAVE_IN SLAVE_IN
  fi
  if [ "$PROTOCOL" = "syncppp" -a -f  etc/ppp/options.${NETDEV} ] ; then
    USER=`grep "^user" etc/ppp/options.${NETDEV}`
    USER=${USER#user}
    USER=`echo $USER`
    echo "USERNAME=$USER" >> $PROVFILE
    SECRET=""
    while read line ; do
      case $line in
	"#"*|"") ;;
	*)
	  read user host secret rest < <(echo "$line")
	  [ "$USER" = "$user" ] && SECRET="$secret" && break
	  ;;
      esac
    done  < <(cat etc/ppp/pap-secrets etc/ppp/chap-secrets)
    echo "PASSWORD=$SECRET" >> $PROVFILE
    USEPEERDNS=`grep "^ms-get-dns" etc/ppp/options.${NETDEV}`
    if [ -z "$USEPEERDNS" ] ; then
      echo "USEPEERDNS=\"no\"" >> $OUT_FILE
    else
      echo "USEPEERDNS=\"yes\"" >> $OUT_FILE
    fi
    DEFAULTROUTE=`grep "^defaultroute" etc/ppp/options.${NETDEV}`
    if [ -z "$DEFAULTROUTE" ] ; then
      echo "DEFAULTROUTE=\"no\"" >> $OUT_FILE
    else
      echo "DEFAULTROUTE=\"yes\"" >> $OUT_FILE
    fi
  fi
  echo -en "\015${esc}[${COLUMNS}C${esc}[10D""${esc}[1;32m""done""${esc}[m\017"
  mv $OUT_FILE $OUTFILE
  mv $tf ${tf}.old
  chmod 600 $PROVFILE
  echo
done 
echo
if [ -f etc/rc.config.d/i4l_hardware.rc.config ]; then
  . etc/rc.config.d/i4l_hardware.rc.config
  mv etc/rc.config.d/i4l_hardware.rc.config etc/rc.config.d/i4l_hardware.rc.config.old
else
  echo "no etc/rc.config.d/i4l_hardware.rc.config"
  exit 0
fi
I="-1"
O="-1"
# create hardware list
HWLST=""
N=0
while read line ; do
  case $line in
    "[Created at"*)
       ISAPNP=${line##[Created at isapnp.*}
       if [ -z "$ISAPNP" ]; then
	 ISAPNP="yes"
       else
         ISAPNP="no"
       fi
       ;;
    "Unique ID:"*)
      N=$(($N + 1))
      HWLST="$HWLST $N"
      if [ "$ISAPNP" = "yes" ]; then
        eval ISAPNP_$N="yes"
        ISAPNP=""
      fi
      read a b id < <(echo $line)
      eval UNID_$N=\$id
      ;;
    "I4L Type:"*)
      read a b typ name < <(echo $line)
      name=${name/[/}
      name=${name/]/}
      eval ITYP_$N=\"\$ITYP_$N \$typ\"
      eval INAME_$N=\"$name\"
      ;;
    *)
      ;;
  esac
done < <(hwinfo --isdn)

rm -f etc/sysconfig/isdn/update.hwscan
echo "\$r/usr/sbin/hwscan --pci" >> etc/sysconfig/isdn/update.hwscan
echo "\$r/usr/sbin/hwscan --isapnp" >> etc/sysconfig/isdn/update.hwscan

while [ $I -lt 99 ]; do
  echo
  I=$(($I + 1))
  echo -n "read old ISDN card config $I"
  eval TYPE=\$I4L_TYPE_$I
  if [ -z "$TYPE" ]; then
    if [ $I -ge 4 ]; then
      I=99
    fi
    echo -en "\015${esc}[${COLUMNS}C${esc}[10D""${esc}[1;33m""nothing""${esc}[m\017"
    continue
  fi
  O=$(($O + 1))
  echo -n " type $TYPE write cfg-contr$O.new"
  OUTFILE=etc/sysconfig/isdn/cfg-contr$O
  OUT_FILE=${OUTFILE}.new
  echo "# generated by oldi4l2new.sh from I4L_$I" > $OUT_FILE
  echo "#" >> $OUT_FILE
  eval SUBTYPE=\$I4L_SUBTYPE_$I
  if [ $TYPE -lt 7999 ]; then
    eval IRQ=\$I4L_IRQ_$I
    # this is the default (not configured) setting
    if [ $TYPE -eq 6 -a -z "$SUBTYPE" -a -z "$IRQ" ]; then
      rm $OUT_FILE
      echo -en "\015${esc}[${COLUMNS}C${esc}[10D""${esc}[1;33m""skiping""${esc}[m\017"
      continue
    fi
    DRIVER="hisax"
  else
    case $TYPE in
      8001)
	case $SUBTYPE in
	  0) DRIVER="b1isa" ;;
	  1) DRIVER="b1pci" ;;
	  2|4|5) DRIVER="b1pcmcia" ;;
	  3) DRIVER="c4" ;;
	esac
	;;
      8010)
	DRIVER="eicon"
	;;
      8030)
	DRIVER="icn"
	;;
      *)
	rm $OUT_FILE
	echo -en "\015${esc}[${COLUMNS}C${esc}[10D""${esc}[1;31m""unknown""${esc}[m\017"
	continue
	;;
    esac
  fi
  write_var _$I I4L_TYPE PARA_TYPE
  write_var _$I I4L_SUBTYPE PARA_SUBTYPE
  echo "DRIVER=\"$DRIVER\"" >> $OUT_FILE
  eval PROTO_NR=\$I4L_PROTOCOL_$I
  case $PROTO_NR in
    1) PROTOCOL="1tr6" ;;
    2) PROTOCOL="euro" ;;
    3) PROTOCOL="leased" ;;
    4) PROTOCOL="ni1" ;;
    *) PROTOCOL="euro" ;;
  esac
  echo "PROTOCOL=\"$PROTOCOL\"" >> $OUT_FILE
  # hardware detection unique handling
  ITYP="$TYPE/$SUBTYPE"
  UNIQUE=""
  test_hw
  if [ -n "$UNIQUE" ]; then
    echo "UNIQUE=\"$UNIQUE\"" >> $OUT_FILE
    echo "hwscan --cfg=yes $UNIQUE" >> etc/sysconfig/isdn/update.hwscan 
  fi
  if [ -n "$HWIDX" ]; then
     eval INAME=\$INAME_$HWIDX
     echo "NAME=\"$INAME\"" >> $OUT_FILE
     eval ISAPNP=\$ISAPNP_$HWIDX
     if [ "$ISAPNP" = "yes" ]; then
       eval I4L_IRQ_$I=""
       eval I4L_IO_$I=""
       eval I4L_MEMBASE_$I=""
     fi
  fi
  write_var _$I I4L_IRQ PARA_IRQ
  write_var _$I I4L_IO PARA_IO
  write_var _$I I4L_MEMBASE PARA_MEMBASE
  write_var _$I I4L_HISAXDEBUG DEBUG
  write_var _$I I4L_EAZMAP EAZMAP "X"
  echo "STARTMODE=\"$STARTMODE\"" >> $OUT_FILE
  echo -en "\015${esc}[${COLUMNS}C${esc}[10D""${esc}[1;32m""done""${esc}[m\017"
  mv $OUT_FILE $OUTFILE
done 
echo
